# README

This package contains all that is required to reproduce our results.
The package consists of three sub-directories: data, log_analysis, and thematic_analysis.

## Thematic Analysis

This directory contains the artifacts produced during the qualitative phase of our study.
The artifacts include:

- Our codebook (codebook.xlsx).
- A list of practices (practices.xlsx) with reasons for application, and challenges encountered during and after application.
- The member checking survey (survey_member_checking.pdf) we sent back to the organizations to verify our themes.
- A list of all the themes (themes.xlsx) gathered from the interviews, along with the results of the member checking survey.

## Case Reports

This directory contains the case reports we created, sent to the organizations, and later updated based on the feedback we received.

## Data

This is the anonymized dataset used to analyze development and build activity.

#### Commits (commits_clean.csv)

- org_id: The organization's ID as given in the paper.
- project_id: Anonymous project identifier which varies per project mined.
- dev_id: A unique _anonymous_ identifier per developer.
- commit_id: A unique _anonymous_ identifier per commit.
- timestamp: A timestamp of when the commit was made. Contains 2 distinct formats (GitHub and BitBucket), but the notebook accounts for it.

#### Builds (builds_clean.csv)

- org_id: The organization's ID as given in the paper.
- project_id: Anonymous project identifier which varies per project mined.
- pr_id: Anonymous pull request identifier included whenever the link between a pull request and a build could be established. Not possible for ORG B.
- build_duration: The amount of time (in minutes) a successful build ran.

## Log Analysis

This directory contains the two Jupyter notebooks used to verify whether practices 4 and 6 were followed.
To run the notebooks, simply use [pipenv](https://pipenv.pypa.io/en/latest/) to install the dependencies, and then run `pipenv run jupyter lab`.
The Jupyter lab environment should open up in a browser window, and you'll be able to browse and run the notebooks.